#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#include "../include/util_gettime.h"

#define L 8

void counting_sort_rec(int n, int x, int M, int *A)
{
  int i, y, *B, *bucketFreq, *CF;

  bucketFreq = (int*)calloc(x+1, sizeof(int));
  y = (int)ceil( (double)(M+1.0)/((double)x) );

  for(i = 0; i < n; ++i)	
    ++bucketFreq[(A[i]/y ) + 1];

  for(i = 1; i <= x; ++i)	
    bucketFreq[i] += bucketFreq[i-1];

  B = (int*)malloc(n*sizeof(int));
  for(i = 0; i < n; ++i)
    B[bucketFreq[A[i]/y ]++] = A[i];

  //printf("Preprocessing is done\n");

  free(bucketFreq);
  //cout<<"Elapsed time for preprocessing: "<< (double)(stop-start)/CLOCKS_PER_SEC<<" seconds"<<endl;

  CF = (int*)calloc(M, sizeof(int));
  
  for(i=0; i < n; ++i)
    ++CF[ B[i] ];

  for(i = 1; i < M; ++i)
    CF[i]+=CF[i-1];
  
  for(i=n-1; i > -1 ; --i){
    A[ CF[ B[i]  ] -1 ] = B[i];
    --CF[ B[i] ];
  }
  
  free(CF);
  free(B);
} 


int main(int argc, char *argv[])
{
  int n, MOD, i, M, Z, *A, *B, x, y, *bucketFreq, *CF;

  long started, ended;
  float timeTaken;

  n = 100000000;
  MOD = n;
  Z = 50000;

  if (argc > 1) n = atoi(argv[1]);
  if (argc > 2) MOD = atoi(argv[2]);
  if (argc > 3) Z = atoi(argv[3]);
  
  A = (int*)malloc(n*sizeof(int));
  
  M = -1;
  for(i = 0; i < n; ++i) {
    A[i] = rand()%MOD;
    if(A[i] > M)
      M = A[i];
  }

  x = Z/(1+L);

  // printf("Input is created. Maximum value is: %d\n", M);
  // printf("Input will be divided into %d groups \n", x);
 
  started = example_get_time();

  counting_sort_rec(n, x, M, A);

  ended = example_get_time();  
  timeTaken = (ended - started)/1.f;
  printf("Running time = %5.0f ms\n", timeTaken);
  
  free(A);

  return 0;

}
  

  
