#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#include "../include/util_gettime.h"

#define L 8

void counting_sort_rec(int n, int x, int M, int *A, int *B)
{
  int i, y, *CF;

  CF = (int*)calloc(M, sizeof(int));
  
  for(i=0; i < n; ++i)
    ++CF[ A[i] ];

  for(i = 1; i < M; ++i)
    CF[i]+=CF[i-1];
  
  for(i=n-1; i > -1 ; --i){
    B[ CF[ A[i]  ] -1 ] = A[i];
    --CF[ A[i] ];
  }
  
  free(CF);
} 


int main(int argc, char *argv[])
{
  int n, MOD, i, M, Z, *A, *B, x, y, *CF;

  long started, ended;
  float timeTaken;

  n = 100000000;
  MOD = n;
  Z = 50000;

  if (argc > 1) n = atoi(argv[1]);
  if (argc > 2) MOD = atoi(argv[2]);
  if (argc > 3) Z = atoi(argv[3]);
  
  A = (int*)malloc(n*sizeof(int));
  B = (int*)malloc(n*sizeof(int));
  
  M = -1;
  for(i = 0; i < n; ++i) {
    A[i] = rand()%MOD;
    if(A[i] > M)
      M = A[i];
  }

  x = Z/(1+L);

  // printf("Input is created. Maximum value is: %d\n", M);
  // printf("Input will be divided into %d groups \n", x);
 
  started = example_get_time();

  counting_sort_rec(n, x, M, A, B);

  ended = example_get_time();  
  timeTaken = (ended - started)/1.f;
  printf("Running time = %5.0f ms\n", timeTaken);
  
  free(A);
  free(B);

  return 0;

}
  

  
