/* Lab 4 Exercise 3 */

#include <stdio.h>
#include <stdlib.h>
#include "../include/util_gettime.h"

void swap_a(int *a, int n, int s, int k, int l, int kk, int ll){ //this function does the swapping of elements between two blocks.

 int i,j,temp,temp1,temp2;

  for(i=0;i<s;i++) { 
    for(j=0;j<s;j++) {
      temp1= (k+i)*n+l+j;
      temp2=(kk+i)*n+ll+j;
      temp= a[temp1];
      a[temp1] = a[temp2];
      a[temp2] = temp;
    }
  }

}

void transpose_DnC(int *a, int n, int s, int Base, int starti, int startj)
{ 
  int temp, i, j;
  if ( s <= Base ){        // when the blocks reach base case means we do not further divide the block, we do traspose naive way
    for(i=0;i<s;i++) {
      for( j=i+1; j<s; j++) {
        temp = a[(starti*n + startj) + i*n + j];
        a[(starti*n + startj) + i*n + j] = a[(starti*n + startj) + j*n + i];
        a[(starti*n + startj) + j*n + i] = temp;
      }
    }
  }
  else if (s > Base ){
      s = s/2;
      transpose_DnC(a,n,s,Base,starti,startj);
      transpose_DnC(a,n,s,Base,starti,startj+s);
      transpose_DnC(a,n,s,Base,starti+s,startj);
      transpose_DnC(a,n,s,Base,starti+s,startj+s);  
  
      swap_a(a, n, s, starti, startj+s, starti+s, startj); // swap between North-East corner block(starti,startj+s) with South-West corner block (starti+s,startj)
  
  }
}

/* Print an n-by-n matrix */
void print_matrix(int* a, int n)
{
  int i,j;
  for(i=0;i<n;i++) {
   for( j=0; j<n; j++) {
     printf("%d   ", a[n*i+j]);
     if (j == n-1) printf("\n");
   }
  }
  printf("\n");
}

/* Create a random n-by-n matrix with range 0 to n-1 */
void random_matrix(int* a, int n)
{
  int i,j;
  for(i=0;i<n;i++) {
    for(j=0;j<n;j++) {
      a[i*n + j] = rand()%n;
    }
  }
}

int main(int argc, char * argv[]) 
{
  int n, s, base, *a;

  long started, ended;
  float timeTaken;

  if(argc != 3){
    printf("Usage: %s n b (n: square matrix size (should be power of 2); b: base size of the block)\n", argv[0]);
    return 0;
  }
  
  n = atoi(argv[1]);
  base = atoi(argv[2]);
  
  s = n * n;
  if (s < 1000000000) {
    a = (int *) malloc(s * sizeof(int));
    random_matrix(a,n);
    
    if (n < 20) {printf("Starting matrix: \n"); print_matrix(a,n);}
    
    started = example_get_time();

    transpose_DnC(a,n,n,base,0,0); /* inital coordinates for block is the first element */
    
    ended = example_get_time();  
    timeTaken = (ended - started)/1.f;
    printf("Running time = %5.0f ms\n", timeTaken);

    if (n < 20) {printf("Transposed matrix: \n"); print_matrix(a,n);}
  }
  
  free(a);
  return 0;
}




 


